import unittest

from prometheus_es_exporter.indices_aliases_parser import parse_response
from tests.utils import convert_result


# Sample responses generated by querying the endpoint on a Elasticsearch
# server populated with the following data (http command = Httpie utility):
# > http -v POST localhost:9200/foo/bar/1 val:=1 group1=a group2=a
# > http -v POST localhost:9200/foo/bar/2 val:=2 group1=a group2=b
# > http -v POST localhost:9200/foo/bar/3 val:=3 group1=b group2=b
# > http -v PUT localhost:9200/foo/_alias/baz
class Test(unittest.TestCase):
    maxDiff = None

    def test_endpoint(self):
        # Endpoint: /_alias?pretty
        response = {
            "foo": {
                "aliases": {
                    "baz": {}
                }
            }
        }

        expected = {
            'alias{index="foo",alias="baz"}': 1,
        }
        result = convert_result(parse_response(response))
        self.assertEqual(expected, result)


if __name__ == '__main__':
    unittest.main()
